#include <stdio.h>
#include <stdlib.h>
#include "pgm.h"

#define arrsize 20
#define elsize 24
#define imsize 488
#define border 4

#define xStartX 2
#define yStartX 2
#define xEndX 6
#define yEndX 17
#define xStartT 12
#define yStartT 2
#define xEndT 17
#define yEndT 17

#define numX 6
#define numL 24
#define numT 24

typedef unsigned char *element;

main()
{
  FILE *f_image, *f_data;
  element X[numX], T[numT], L[numL];
  unsigned char image[imsize*imsize];
  int i, y, x;
  char t_name[30], f_name[30];
  long randNum;

  strcpy(f_name, "X/X"); 
  init_els(X, numX, f_name, 3);
  strcpy(f_name, "T/T"); 
  init_els(T, numT, f_name, 3);
  strcpy(f_name, "L/L"); 
  init_els(L, numL, f_name, 3);

  for(i=0; i<imsize*imsize; i++)  image[i]=0;

  f_data=fopen("data", "w");

  srandom(87297211);
  for (y=0; y<arrsize; y++)
  {
    for (x=0; x<arrsize; x++)
    {
      randNum=random();
      if ((x>=xStartX) && (x<=xEndX) &&
          (y>=yStartX) && (y<=yEndX))
      {
    	copy_el(image, X[randNum%numX], y*elsize, x*elsize);
	/*fprintf(f_data, "%d\t", randNum%numX);*/
      }
      else if ((x>=xStartT) && (x<=xEndT) &&
               (y>=yStartT) && (y<=yEndT))
      {
    	copy_el(image, T[randNum%numT], y*elsize, x*elsize);
	fprintf(f_data, "%d\t", randNum%numT);
      }
      else
      {
    	copy_el(image, L[randNum%numL], y*elsize, x*elsize);
/*	fprintf(f_data, "%d\t", randNum%numL);*/
      }
    }
    fprintf(f_data, "\n");
  }

  strcpy(f_name, "myBergen1.pgm");
  write_pgm(f_name, image, imsize, imsize, 255);
}



int output_el(element image)
{
  int i,j,k,m;
  FILE *out;
  element tempel;
  char f_out[]="temp.pgm";

  out=fopen(f_out, "w");

  fprintf(out,"P5\n%d %d %d\n", elsize, elsize, 255);
  for (i=0; i<elsize; i++)
    for (j=0; j<elsize; j++)
      fprintf(out, "%c", image[i*elsize+j]);

  fclose(out);
}




int copy_el(unsigned char *image, element el, int y, int x)
{
  int i,j;

  for (i=0; i<elsize; i++)
    for (j=0; j<elsize; j++)
      image[(y+i+border)*imsize+(x+j+border)]=el[i*elsize+j];
}




int init_els(element *els, int numEls, char *fname, int index)
{
  int i=0,j,k;
  FILE *in;
  int fnameNum;
  int t1, t2;
  char *fnamePtr;

  for(i=0; i<numEls; i++)
  {
    fnameNum = i*15;
    if (fnameNum<100)
    {
      if (fnameNum==0)
      {
      	strcpy(fname+index, "000");
      }
      else
      {
        fname[index]='0';
        fnamePtr = fname+index+1;
        sprintf(fname+index+1, "%d", fnameNum);
      }
    }
    else
    {
      sprintf(fname+index, "%d", fnameNum);
    }
    strcat(fname, ".pgm");
    /*printf("%s\n", fname);*/

    read_pgm(fname, &(els[i]), &t1, &t2);

  }
}
